#include <stdio.h>
#include <string.h>
#include <conio.h>

FILE *infile;
FILE *outfile;
int chan, maxchan;
long Rx, Tx;
char Data [100];
int Line;
unsigned char eprom[0x800];



void do_parity (unsigned char *data)

{
    unsigned char i,j,k;
    
    i = data[0] ^ data[1] ^ data[2];
    k = 0;
    for (j=0; j < 8; j++) {
	if (i & 0x01) {
	    k++;
	}
	i >>= 1;
    }
    if (k & 0x01) {
	data[0] |= 0x40;
    }
}



void main (void)

{
    int temp;
    unsigned char *div;

    printf ("Programmer for Midland 70-340B Radio - Version 1.00\n");
    printf ("Peter Baston 24th Oct 1996\n\n");
    
    
    outfile = fopen ("MIDLAND.BIN","w+b");
    if (NULL == (infile = fopen ("MIDLAND.PRG", "r"))) {
	fclose (outfile);
	printf ("Error opening file: MIDLAND.PRG\n");
	exit (0);
    }
    
    for (temp=0; temp < 0x800; temp++) {
	eprom[temp] = 0xFF;
    }
    
    eprom[0x400] = 0x00;	// ??
    eprom[0x404] = 0x72;	// ??
    eprom[0x408] = 0x00;	// number of channels
    eprom[0x40C] = 0x56;	// ??
    eprom[0x410] = 0x32;	// ??
    
    
    Line = 0;
    maxchan = 1;

    while (1) {
	fgets (Data, 95, infile);
	if (feof (infile)) {
	    break;
	}
	temp = sscanf (Data, "%d %ld %ld", &chan, &Rx, &Tx);
	if (temp != 3) {
	    break;
	}

	Rx -= 21400;	// subtract 21.4 IF
	Rx /= 5;	// 5Khz channel spacing
	div = &eprom[((chan /10) * 0x40) + ((chan % 10) * 4) + 1];
	div[0] = (Rx >> 14) & 0xff;
	div[1] = (Rx >> 6) & 0xff;
	div[2] = (Rx << 1) & 0x7f;
	do_parity (div);
	
	Tx -= 20480;	// subtract 20.48 IF
	Tx /= 5;	// 5Khz channel spacing
	div = &eprom[0x400 + ((chan / 10) * 0x40) + ((chan % 10) * 4) + 1];
	div[0] = (Tx >> 14) & 0xff;
	div[1] = (Tx >> 6) & 0xff;
	div[2] = (Tx << 1) & 0x7f;
	do_parity (div);	
	
	if (maxchan < chan) {
	    maxchan = chan;
	}
	
	Line++;
	
    }
    fclose (infile);
    eprom[0x408] = (unsigned char) ((maxchan / 10) * 0x10) + (maxchan % 10);
    fwrite (eprom, 0x800, 1, outfile);
    fclose (outfile);
    printf ("Processing Succesfully Completed !\n");
    printf ("Channels Programmed: %d\n", Line);

}/* main */
